Package org.apache.tomcat.util.buf

## Interface ByteChunk.ByteOutputChannel

- Enclosing class:
    ByteChunk

      public static interface ByteChunk.ByteOutputChannel

  When we need more space we'll either grow the buffer ( up to the limit ) or send it to a channel. Same as java.nio.channel.WritableByteChannel.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `realWriteBytes​(byte[] buf, int off, int len)` | Send the bytes ( usually the internal conversion buffer ).
    `void` | `realWriteBytes​(java.nio.ByteBuffer from)` | Send the bytes ( usually the internal conversion buffer ).

- - ### Method Detail

    - #### realWriteBytes

          void realWriteBytes​(byte[] buf,
                              int off,
                              int len)
                       throws java.io.IOException

      Send the bytes ( usually the internal conversion buffer ). Expect 8k output if the buffer is full.
      Parameters:
        `buf` - bytes that will be written
        `off` - offset in the bytes array
        `len` - length that will be written
      Throws:
        `java.io.IOException` - If an I/O occurs while writing the bytes

    - #### realWriteBytes

          void realWriteBytes​(java.nio.ByteBuffer from)
                       throws java.io.IOException

      Send the bytes ( usually the internal conversion buffer ). Expect 8k output if the buffer is full.
      Parameters:
        `from` - bytes that will be written
      Throws:
        `java.io.IOException` - If an I/O occurs while writing the bytes